<?php

defined('IN_MET') or exit('No permission');
load::sys_class('admin');

class easy_360safe extends admin {
	public function __construct() {
        global $_M;
		parent::__construct();
        nav::set_nav(1, "防护开关", $_M['url']['own_form'].'a=doindex');
        nav::set_nav(2, "防护设置", $_M['url']['own_form'].'a=doconfig');
	}
	public function doindex() {
        global $_M;
        nav::select_nav(1);
        $safe_dir = PATH_WEB."360safe";
        $config_dir = PATH_WEB."config";
        if(is_dir($safe_dir) && is_file($config_dir."/config.inc.bak.php")) {
            $safe_start = 1;
        } else {
            $safe_start = 0;
        }
		require_once $this -> template('own/index');
	}
    public function doconfig() {
        global $_M;
        nav::select_nav(2);
        $config_file = PATH_APP_FILE."plugin/360safe/webscan_cache.php";
        $webscan_post = $this -> doget_config($config_file,"webscan_post","int");
        $webscan_get = $this -> doget_config($config_file,"webscan_get","int");
        $webscan_cookie = $this -> doget_config($config_file,"webscan_cookie","int");
        $webscan_referre = $this -> doget_config($config_file,"webscan_referre","int");
        $webscan_white_directory = $this -> doget_config($config_file,"webscan_white_directory");
        require_once $this -> template('own/config');
    }

    public function doerror() {
        global $_M;
        require_once $this -> template('own/error');
    }

    public function doconfig_save() {
        global $_M;
        $config_file = PATH_APP_FILE."plugin/360safe/webscan_cache.php";
        if (substr(base_convert(@fileperms($config_file),10,8),-4) != 0644) {
            chmod($config_file, 0644);
        }
        $webscan_post = $_M[form]['webscan_post'];
        $webscan_get = $_M[form]['webscan_get'];
        $webscan_cookie = $_M[form]['webscan_cookie'];
        $webscan_referre = $_M[form]['webscan_referre'];
        $webscan_white_directory = $_M[form]['webscan_white_directory'];
        $this -> doupdate_config($config_file, "webscan_post", $webscan_post, "int");
        $this -> doupdate_config($config_file, "webscan_get", $webscan_get, "int");
        $this -> doupdate_config($config_file, "webscan_cookie", $webscan_cookie, "int");
        $this -> doupdate_config($config_file, "webscan_referre", $webscan_referre, "int");
        $this -> doupdate_config($config_file, "webscan_white_directory", $webscan_white_directory);
        turnover("{$_M[url][own_form]}a=doconfig","保存成功");
    }

    public function docheck() {
        global $_M;
        $safe_dir = PATH_WEB."webscan360";
        if(is_dir($safe_dir)) {
            turnover("{$_M[url][own_form]}a=doerror","开启失败");
        } else {
            $this -> dostart();
        }
    }

    public function dostart() {
        global $_M;
        $safe_dir = PATH_WEB."360safe";
        $safe_app_dir = PATH_APP_FILE."plugin/360safe";
        $config_dir = PATH_WEB."config";
        $easy_360safe_start = $_M[form]['easy_360safe_start'];
        if ($easy_360safe_start == 1) {
            unlink($safe_dir."/360webscan.php");
            unlink($safe_dir."/webscan_cache.php");
            rmdir($safe_dir);
            unlink($config_dir."/config.inc.php");
            copy($config_dir."/config.inc.bak.php",$config_dir."/config.inc.php");
            if(is_file($config_dir."/config.inc.php")) {
                unlink($config_dir."/config.inc.bak.php");
            }
            turnover("{$_M[url][own_form]}a=doindex","关闭成功");
        } else {
            mkdir($safe_dir,0755);
            if(is_dir($safe_dir)) {
                copy($safe_app_dir."/360webscan.php",$safe_dir."/360webscan.php");
                copy($safe_app_dir."/webscan_cache.php",$safe_dir."/webscan_cache.php");
            }
            copy($config_dir."/config.inc.php",$config_dir."/config.inc.bak.php");
            $text1 = file_get_contents($safe_app_dir."/360webscan.inc.php");
            $text2 = file_get_contents($config_dir."/config.inc.bak.php");
            if(is_file($config_dir."/config.inc.bak.php")) {
                unlink($config_dir."/config.inc.php");
            }
            $file = fopen($config_dir."/config.inc.php","w");
            fwrite($file,$text1."\n".$text2);
            fclose($file);
            if(is_file($config_dir."/config.inc.bak.php")) {
                turnover("{$_M[url][own_form]}a=doindex","开启成功");
            } else {
                turnover("{$_M[url][own_form]}a=doindex","开启失败，请检查文件权限！");
            }
        }
    }

    public function doget_config($file, $ini, $type="string"){
        global $_M;
        if(!file_exists($file)) return false;
        $str = file_get_contents($file);
        if ($type=="int"){
            $config = preg_match("/".preg_quote($ini)."=(.*);/", $str, $res);
            return $res[1];
        }
        else{
            $config = preg_match("/".preg_quote($ini)."=\"(.*)\";/", $str, $res);
            if($res[1]==null){  
                $config = preg_match("/".preg_quote($ini)."='(.*)';/", $str, $res);
            }
            return $res[1];
        }
    }

    public function doupdate_config($file, $ini, $value,$type="string"){
        global $_M;
        if(!file_exists($file)) return false;
        $str = file_get_contents($file);
        $str2="";
        if($type=="int"){   
            $str2 = preg_replace("/".preg_quote($ini)."=(.*);/", $ini."=".$value.";",$str);
        }
        else{
            $str2 = preg_replace("/".preg_quote($ini)."=(.*);/", $ini."=\"".$value."\";",$str);
        }
        file_put_contents($file, $str2);
    }
}
?>