<?php

defined('IN_MET') or exit('No permission');
load::sys_class('admin');
load::sys_func('file');

class met_wechat extends admin
{
    public function __construct()
    {
        global $_M;
        parent::__construct();
        require_once PATH_APP_FILE . 'lang/lang.php';
        $this->L_cn     = $_L['lang']['cn'];
        $this->LW_BASE  = load::own_class('LW_BASE', 'new');
        $this->LW_REPLY = load::own_class('LW_REPLY', 'new');
        load::own_class('LW');
        $arr = array(
            array(1, "公众号设置", "index"),
            array(2, "其它设置", "config"),
            array(3, "菜单设置", "menu"),
            array(4, "关键词管理", "keywords"),
            array(5, "回复管理", "reply"),
            array(6, "图文素材", "news"),
            array(7, "用户列表", "user"),
            array(8, "积分详情", "points"),
            array(9, "检查更新", "update"),
            array(10, "帮助", "help"),
        );
        LW::set_nav($arr);
    }
    /**
     * 公众号设置
     */
    public function doindex()
    {
        global $_M;
        nav::select_nav(1);
        $action = $_M['form']['action'];
        $config = LW::config('get', '', '', 'metinfo');

        switch ($action) {
            case 'save':
                LW::config('save', '', '', 'metinfo');
                $oldfile = PATH_WEB . $config['wechat_dir'];
                $newfile = PATH_WEB . $_M['form']['LC']['wechat_dir'];
                if ($config['wechat_dir'] && $oldfile != $newfile) {
                    movedir($oldfile, $newfile);
                }
                turnover(HTTP_REFERER);
                break;
            case 'testapi':
                header("Content-type: text/html; charset=utf-8");
                header("Cache-Control: no-cache");
                $r = $this->LW_BASE->get_access_token();
                if (is_array($r)) {
                    echo '接入失败！';
                    echo '<br>错误代码：' . $r['errcode'];
                    echo '<br>错误原因：' . $r['errmsg'];
                    echo '<br>自行百度错误编码，查看解决办法！';
                } else {
                    echo '接入成功';
                }
                break;

            default:
                $link[0]['name'] = '积分详情';
                $link[0]['url']  = $this->LW_BASE->self_url('jf');
                $link[1]['name'] = '扫码关注页面';
                $link[1]['url']  = $this->LW_BASE->self_url('qrcode');
                $link[2]['name'] = 'jsapiticket接口';
                $link[2]['url']  = $this->LW_BASE->self_url('met_wechat', 'met_wechat', 'doget_jsapiticket') . '&token=' . $config['wechat_token'];
                $token_url       = $this->LW_BASE->self_url('met_wechat', 'met_wechat', 'doent');
                require_once $this->template('own/index');
                break;
        }
    }
    /**
     * 其它设置
     */
    public function doconfig()
    {
        global $_M;
        nav::select_nav(2);
        $action = $_M['form']['action'];

        switch ($action) {
            case 'save':
                LW::config('save', '', '', 'metinfo');
                turnover(HTTP_REFERER);
                break;
            default:
                $sub_data  = LW::sql_get_one("nwechat_reply", "id = '1'");
                $auto_data = LW::sql_get_one("nwechat_reply", "id = '2'");
                $config    = LW::config('get', '', '', 'metinfo');
                require_once $this->template('own/config');
                break;
        }
    }
    /**
     * 菜单设置
     */
    public function domenu()
    {
        global $_M;
        nav::select_nav(3);
        $action     = $_M['form']['action'];
        $table_menu = $_M['table']['nwechat_menu'];

        switch ($action) {
            case 'ajax_table':
                $table = load::sys_class('tabledata', 'new');
                $array = $table->getdata($_M['table']['nwechat_menu'], '*', "topid=0", "order_no ASC");
                foreach ($array as $key => $val) {
                    $menudata = LW::sql_get_all("nwechat_menu", "topid = {$val['id']}", "order_no ASC");
                    $select   = $menudata ? "一级菜单" : "
                            <select name='LC[{$val[id]}][type]' data-checked='{$val[type]}'>
                                <option value='click'>关键词</option>
                                <option value='view'>URL链接</option>
                                <option value='miniprogram'>小程序</option>
                            </select>
                        ";
                    $value = $menudata ? "不可填值" : "
                            <input type='text' name='LC[{$val[id]}][value]' class='ui-input' value='{$val[value]}'>
                        ";
                    $list   = array();
                    $list[] = "<input name='id' type='checkbox' value='{$val[id]}'>";
                    $list[] = "
                            <div class='input-group'>
                                <span class='input-group-addon' style='background:#565555;color:#fff'>一级菜单</span>
                                <input type='text' name='LC[{$val[id]}][order_no]' class='ui-input met-center' value='{$val[order_no]}'>
                            </div>
                        ";
                    $list[] = "<input type='text' name='LC[{$val[id]}][name]' class='ui-input' value='" . urldecode($val[name]) . "'>";
                    $list[] = $select;
                    $list[] = $value;
                    $list[] = '
                            <div class="btn-group">
                                <a href="javascript:0;" class="btn btn-info" data-href="' . $_M[url][own_form] . 'a=domenu&action=ajax_add_tr&topid=' . $val[id] . '" onclick="L_get_ajax($(this));">添加二级菜单</a>
                                <a href="' . $_M[url][own_form] . 'a=domenu&action=table&submit_type=del&allid=' . $val[id] . '" class="btn btn-danger" data-confirm="确认删除？">删除</a>
                                <script>function L_get_ajax(obj) {var url = obj.attr("data-href");obj.html("请稍后...");$.ajax({type: "get",url: url,dataType: "html",success: function(data){obj.parent("div").parent("td").parent("tr").after(data);obj.html("添加二级菜单");},error: function (XMLHttpRequest, textStatus, errorThrown) {}});}</script>
                            </div>
                        ';
                    $rarray[] = $list;
                    foreach ($menudata as $key => $val2) {
                        $list   = array();
                        $list[] = '<input name="id" type="checkbox" value="' . $val2[id] . '">';
                        $list[] = '<div class="input-group"><span class="input-group-addon"><img src="' . $_M[url][site_admin] . 'templates/met/images/bg_columnx.gif"> 二级菜单</span><input type="text" name="LC[' . $val2[id] . '][order_no]" class="ui-input met-center" value="' . $val2[order_no] . '"></div>';
                        $list[] = '<input type="text" name="LC[' . $val2[id] . '][name]" class="ui-input" value="' . urldecode($val2[name]) . '">';
                        $list[] = '<select name="LC[' . $val2[id] . '][type]" data-checked="' . $val2[type] . '"><option value="click">关键词</option><option value="view">URL链接</option><option value="miniprogram">小程序</option></select>';
                        $list[] = '<input type="text" name="LC[' . $val2[id] . '][value]" class="ui-input" value="' . $val2[value] . '">';
                        $list[] = '
                            <div class="btn-group">
                                <a href="' . $_M[url][own_form] . 'a=domenu&action=table&submit_type=del&allid=' . $val2[id] . '" class="btn btn-danger" data-confirm="确认删除？">删除</a>
                            </div>
                        ';
                        $rarray[] = $list;
                    }
                }

                $table->rdata($rarray);
                break;

            case 'table':
                LW::save_table("nwechat_menu");
                turnover(HTTP_REFERER);
                break;

            case 'ajax_add_tr':
                if ($_M[form][topid]) {
                    $id   = 'new-' . time();
                    $html = '<tr class="even newlist">'
                        . '<td><input name="id" type="checkbox" value="' . $id . '" checked><input name="LC[' . $id . '][topid]" type="hidden" value="' . $_M[form][topid] . '"></td>'
                        . '<td><div class="input-group"><span class="input-group-addon"><img src="' . $_M[url][site_admin] . 'templates/met/images/bg_columnx.gif"> 二级菜单</span><input type="text" name="LC[' . $id . '][order_no]" class="ui-input met-center" value=""></div></td>'
                        . '<td><input type="text" name="LC[' . $id . '][name]" class="ui-input" value=""></td>'
                        . '<td><select name="LC[' . $id . '][type]"><option value="click">关键词</option><option value="view">URL链接</option><option value="miniprogram">小程序</option></select></td>'
                        . '<td><input type="text" name="LC[' . $id . '][value]" class="ui-input" value=""></td>'
                        . '<td><a href="" class="btn btn-warning delet">撤销</a></td>'
                        . '</tr>';
                } else {
                    $id           = 'new-' . $_M[form][ai];
                    $menu_counter = LW::sql_count("nwechat_menu", "topid = 0");
                    if ($menu_counter > '2' || ($menu_counter + $_M[form][ai]) > '2') {
                        echo "<script>alert('最多只能设置3个一级菜单');</script>";
                        die;
                    }
                    $html = '<tr class="even newlist">'
                        . '<td><input name="id" type="checkbox" value="' . $id . '" checked></td>'
                        . '<td><div class="input-group"><span class="input-group-addon">一级菜单</span><input type="text" name="LC[' . $id . '][order_no]" class="ui-input met-center" value=""></div></td>'
                        . '<td><input type="text" name="LC[' . $id . '][name]" class="ui-input" value=""></td>'
                        . '<td><select name="LC[' . $id . '][type]"><option value="">一级菜单</option><option value="click">关键词</option><option value="view">URL链接</option><option value="miniprogram">小程序</option></select></td>'
                        . '<td><input type="text" name="LC[' . $id . '][value]" class="ui-input" value=""></td>'
                        . '<td><a href="" class="btn btn-warning delet">撤销</a></td>'
                        . '</tr>';
                }
                echo $html;
                break;

            case 'fabu':
                $menudata = LW::sql_get_all("nwechat_menu", "topid = 0", "order_no ASC");
                $menu     = array();
                $i        = 0;
                foreach ($menudata as $key => $val) {
                    $val['name'] = urlencode($val['name']);
                    $menu2data   = LW::sql_get_all("nwechat_menu", "topid = {$val['id']}", "order_no ASC");
                    if ($menu2data) {
                        $menu['button'][$i]['name'] = $val['name'];
                        $k                          = 0;
                        foreach ($menu2data as $key => $val2) {
                            $val2['name']                                 = urlencode($val2['name']);
                            $menu['button'][$i]['sub_button'][$k]['type'] = $val2['type'];
                            $menu['button'][$i]['sub_button'][$k]['name'] = $val2['name'];
                            switch ($val2['type']) {
                                case 'click':
                                    $menu['button'][$i]['sub_button'][$k]['key'] = urlencode($val2['value']);
                                    break;
                                case 'view':
                                    $menu['button'][$i]['sub_button'][$k]['url'] = $val2['value'];
                                    break;
                                case 'miniprogram':
                                    $minidata                                         = explode("||", $val2['value']);
                                    $menu['button'][$i]['sub_button'][$k]['url']      = $minidata[0];
                                    $menu['button'][$i]['sub_button'][$k]['appid']    = $minidata[1];
                                    $menu['button'][$i]['sub_button'][$k]['pagepath'] = $minidata[2];
                                    break;
                                default:
                                    $menu['button'][$i]['sub_button'][$k]['url'] = $val2['value'];
                                    break;
                            }
                            $k++;
                        }
                    } else {
                        $menu['button'][$i]['type'] = $val['type'];
                        $menu['button'][$i]['name'] = $val['name'];
                        switch ($val['type']) {
                            case 'click':
                                $menu['button'][$i]['key'] = urlencode($val['value']);
                                break;
                            case 'view':
                                $menu['button'][$i]['url'] = $val['value'];
                                break;
                            case 'miniprogram':
                                $minidata                       = explode("||", $val['value']);
                                $menu['button'][$i]['url']      = $minidata[0];
                                $menu['button'][$i]['appid']    = $minidata[1];
                                $menu['button'][$i]['pagepath'] = $minidata[2];
                                break;
                            default:
                                $menu['button'][$i]['url'] = $val['value'];
                                break;
                        }
                    }
                    $i++;
                }
                $data = $this->LW_BASE->post_menu($menu);
                if ($data['errcode'] == '0') {
                    turnover("{$_M['url']['own_form']}a=domenu");
                } elseif (!$data['errcode']) {
                    turnover("{$_M['url']['own_form']}a=domenu", '接口请求超时！');
                } else {
                    turnover("{$_M['url']['own_form']}a=domenu", '发布失败，错误码：' . $data['errcode'] . ' 错误原因：' . $data['errmsg']);
                }
                break;
            case 'getmenu':
                $data = $this->LW_BASE->default_menu();
                if ($data == '1') {
                    turnover("{$_M['url']['own_form']}a=domenu");
                } else {
                    turnover("{$_M['url']['own_form']}a=domenu", '获取失败，错误码：' . $data['errcode'] . ' 错误原因：' . $data['errmsg']);
                }
                break;

            default:
                require_once $this->template('own/menu');
                break;
        }
    }
    /**
     * 关键词管理--列表
     */
    public function dokeywords()
    {
        global $_M;
        nav::select_nav(4);
        $action = $_M['form']['action'];

        switch ($action) {
            case 'ajax_table':
                $key1   = $_M['form']['search_word'];
                $search = $key1 ? " AND word LIKE '%" . $key1 . "%' " : "";
                $table  = load::sys_class('tabledata', 'new');
                $array  = $table->getdata($_M['table']['nwechat_keywords'], '*', "is_own!=1" . $search, "id DESC");

                foreach ($array as $key => $val) {
                    $val['type'] = $val['type'] == '1' ? '精确匹配' : '模糊匹配';
                    $list        = array();
                    $list[]      = '<input name="id" type="checkbox" value="' . $val[id] . '">';
                    $list[]      = $val['type'];
                    $list[]      = $val['replyid'];
                    $list[]      = $val['word'];
                    $list[]      = '
                            <div class="btn-group">
                                <a href="' . $_M[url][own_form] . 'a=dokeywords&action=edit&id=' . $val[id] . '" class="btn btn-primary">编辑</a>
                                <a href="' . $_M[url][own_form] . 'a=dokeywords&action=save_table&submit_type=del&allid=' . $val[id] . '" class="btn btn-danger" data-confirm="确认删除？">删除</a>
                            </div>
                        ';
                    $rarray[] = $list;
                }
                $table->rdata($rarray);
                break;

            case 'edit':
                $data = LW::sql_get_one("nwechat_keywords", "id = {$_M['form']['id']} AND is_own != 1");
                require_once $this->template('own/keywords_edit');
                break;
            case 'ajax_table_reply':
                $key1   = $_M['form']['search_reply'];
                $search = $key1 ? " AND name LIKE '%" . $key1 . "%' " : "";
                $table  = load::sys_class('tabledata', 'new');
                $array  = $table->getdata($_M['table']['nwechat_reply'], '*', "isown!=1" . $search, "id DESC");

                foreach ($array as $key => $val) {
                    $list   = array();
                    $list[] = $val['id'];
                    $list[] = $this->L_cn[$val['type']];
                    $list[] = $val['name'];
                    $list[] = "
                        <a href='javascript:;' onclick='L_add_reply(" . $val[id] . ");' class='edit'>选择</a>
                        <script>
                            function L_add_reply (id) {
                                var old_list = $('#reply_list').val();
                                var new_list = old_list+'|'+id;
                                $('#reply_list').val(new_list);
                                $('.replys .tags_tj').before('<li class=tags_list><span>'+id+'</span><a></a></li>');
                            }
                        </script>";
                    $rarray[] = $list;
                }

                $table->rdata($rarray);
                break;
            case 'save':
                LW::save_form("nwechat_keywords");
                turnover("{$_M['url']['own_form']}a=dokeywords");
                break;
            case 'save_table':
                LW::save_table("nwechat_keywords");
                turnover(HTTP_REFERER);
                break;

            default:
                require_once $this->template('own/keywords');
                break;
        }
    }
    /**
     * 关键词管理--内容
     */
    public function doreply()
    {
        global $_M;
        nav::select_nav(5);
        $action = $_M['form']['action'];

        switch ($action) {
            case 'ajax_table':
                $key1   = $_M['form']['search_name'];
                $search = $key1 ? " AND name LIKE '%" . $key1 . "%' " : "";
                $table  = load::sys_class('tabledata', 'new');
                $array  = $table->getdata($_M['table']['nwechat_reply'], '*', "isown!=1" . $search, "id DESC");

                foreach ($array as $key => $val) {
                    $list   = array();
                    $list[] = '<input name="id" type="checkbox" value="' . $val[id] . '">';
                    $list[] = $val['id'];
                    $list[] = $this->L_cn[$val['type']];
                    $list[] = $val['name'];
                    $list[] = '
                            <div class="btn-group">
                                <a href="' . $_M[url][own_form] . 'a=doreply&action=edit&id=' . $val[id] . '" class="btn btn-primary">编辑</a>
                                <a href="' . $_M[url][own_form] . 'a=doreply&action=save_table&submit_type=del&allid=' . $val[id] . '" class="btn btn-danger" data-confirm="确认删除？">删除</a>
                            </div>
                        ';
                    $rarray[] = $list;
                }

                $table->rdata($rarray);
                break;
            case 'save_table':
                LW::save_table("nwechat_reply");
                turnover(HTTP_REFERER);
                break;
            case 'edit':
                $id      = $_M['form']['id'];
                $data    = LW::sql_get_one("nwechat_reply", "id = {$id} AND isown != 1");
                $columns = explode("-", $data[columns]);
                require_once $this->template('own/reply_edit');
                break;
            case 'ajax_column':
                $column_c                              = array("2", "3", "4", "5");
                $array                                 = column_sorting(2); //获取栏目数组
                $metinfo                               = array();
                $i                                     = 0;
                $metinfo['citylist'][$i]['p']['name']  = '请选择';
                $metinfo['citylist'][$i]['p']['value'] = '-';
                foreach ($array['class1'] as $key => $val) {
                    if (in_array($val[module], $column_c)) {
                        $i++;
                        $metinfo['citylist'][$i]['p']['name']  = $val[name];
                        $metinfo['citylist'][$i]['p']['value'] = $val[module] . "-" . $val[id];
                        if (count($array['class2'][$val[id]])) {
                            $k                                              = 0;
                            $metinfo['citylist'][$i]['c'][$k]['n']['name']  = '二级栏目所有内容';
                            $metinfo['citylist'][$i]['c'][$k]['n']['value'] = ' ';
                            foreach ($array['class2'][$val[id]] as $key => $val2) {
                                $k++;
                                $metinfo['citylist'][$i]['c'][$k]['n']['name']  = $val2[name];
                                $metinfo['citylist'][$i]['c'][$k]['n']['value'] = $val2[id];
                                if (count($array['class3'][$val2[id]])) {
                                    $j                                                       = 0;
                                    $metinfo['citylist'][$i]['c'][$k]['a'][$j]['s']['name']  = '三级栏目所有内容';
                                    $metinfo['citylist'][$i]['c'][$k]['a'][$j]['s']['value'] = ' ';
                                    foreach ($array['class3'][$val2[id]] as $key => $val3) {
                                        $j++;
                                        $metinfo['citylist'][$i]['c'][$k]['a'][$j]['s']['name']  = $val3[name];
                                        $metinfo['citylist'][$i]['c'][$k]['a'][$j]['s']['value'] = $val3[id];
                                    }
                                }
                            }
                        }
                    }
                }
                echo json_encode($metinfo);
                break;
            case 'save':
                $arr = array(
                    "id"   => $_M['form']['LC']['id'],
                    "name" => $_M['form']['LC']['name'],
                    "type" => $_M['form']['LC']['type'],
                );
                switch ($_M['form']['LC']['type']) {
                    case 'text':
                        $arr['text'] = str_replace("%5C", "", urlencode($_M['form']['LC']['text']));
                        break;
                    case 'image':
                        if ($_M['form']['image_url_old'] == $_M['form']['image_url']) {
                            $r['media_id'] = $_M['form']['image_mediaid'];
                        } else {
                            $filename = str_replace("/", "\\", str_replace("../", "", $_M['form']['image_url']));
                            $r        = $this->LW_BASE->add_material($filename, 'image', $_M['form']['material']);
                        }
                        $arr['url']     = $_M['form']['image_url'];
                        $arr['mediaid'] = $r['media_id'];
                        break;
                    case 'voice':
                        if ($_M['form']['voice_url_old'] == $_M['form']['voice_url']) {
                            $r['media_id'] = $_M['form']['voice_mediaid'];
                        } else {
                            $filename = str_replace("/", "\\", str_replace("../", "", $_M['form']['voice_url']));
                            $r        = $this->LW_BASE->add_material($filename, 'voice', $_M['form']['material']);
                        }
                        $arr['url']     = $_M['form']['voice_url'];
                        $arr['mediaid'] = $r['media_id'];
                        break;
                    case 'news':
                        $arr['msg_list'] = $_M['form']['LC']['msg_list'];
                        break;
                    case 'column':
                        $columns        = implode("-", $_M['form']['LC']['column']);
                        $arr['columns'] = $columns;
                        break;
                }
                $_M['form']['LC'] = $arr;
                LW::save_form("nwechat_reply");
                turnover("{$_M[url][own_form]}a=doreply");
                break;
            default:
                require_once $this->template('own/reply');
                break;
        }
    }
    /**
     * 图文素材
     */
    public function donews()
    {
        global $_M;
        nav::select_nav(6);
        $action = $_M['form']['action'];

        switch ($action) {
            case 'ajax_table':
                $key1   = $_M['form']['search_title'];
                $search = $key1 ? "title LIKE '%" . $key1 . "%'" : "id!=0";
                $table  = load::sys_class('tabledata', 'new');
                $array  = $table->getdata($_M['table']['nwechat_news'], '*', $search, "id DESC");

                foreach ($array as $key => $val) {
                    $list   = array();
                    $list[] = '<input name="id" type="checkbox" value="' . $val[id] . '">';
                    $list[] = '<img src="' . $val[img] . '" width="100%" height="50px">';
                    $list[] = '<a href="' . $this->LW_BASE->self_url('', '', 'domsg_tmp') . '&action=detail&id=' . $val[id] . '" target="_blank">' . $val['title'] . '</a>';
                    $list[] = $val['all_read'];
                    $list[] = date("Y-m-d H:i:s", $val[addtime]);
                    $list[] = '
                            <div class="btn-group">
                                <a href="' . $_M[url][own_form] . 'a=donews&action=edit&id=' . $val[id] . '" class="btn btn-primary">编辑</a>
                                <a href="' . $_M[url][own_form] . 'a=donews&action=del&submit_type=del&allid=' . $val[id] . '" class="btn btn-danger" data-confirm="确认删除？">删除</a>
                            </div>
                        ';
                    $rarray[] = $list;
                }
                $table->rdata($rarray);
                break;
            case 'edit':
                $data            = LW::sql_get_one("nwechat_news", "id = {$_M['form']['id']}");
                $data['content'] = LW::edit_decode($data['content']);
                require_once $this->template('own/news_edit');
                break;
            case 'save':
                $_M['form']['LC']['addtime']     = time();
                $_M['form']['LC']['description'] = $_M['form']['LC']['description'] ? $_M['form']['LC']['description'] : mb_substr(str_replace(array("\n", "\r", "\t", " ", "　", "&nbsp;"), '', strip_tags($_M['form']['LC']['content'])), 0, 200, 'utf-8');
                $_M['form']['LC']['content']     = LW::edit_encode($_M['form']['LC']['content']);
                LW::save_form("nwechat_news");
                turnover("{$_M[url][own_form]}a=donews");
                break;
            case 'del':
                LW::save_table("nwechat_news");
                turnover(HTTP_REFERER);
                break;
            case 'ajax_table_reply':
                $key1   = $_M['form']['search_reply'];
                $search = $key1 ? "title LIKE '%" . $key1 . "%'" : "id!=0";
                $table  = load::sys_class('tabledata', 'new');
                $array  = $table->getdata($_M['table']['nwechat_news'], '*', $search, "id DESC");

                foreach ($array as $key => $val) {
                    $list     = array();
                    $list[]   = $val[id] . '<input type="hidden" value="' . $val[id] . '" name="id" checked>';
                    $list[]   = '<img src="' . $val[img] . '" width="100%" height="50px">';
                    $list[]   = '<a href="' . $this->LW_BASE->self_url('met_wechat', 'met_wechat', 'domsg_tmp') . '&action=detail&id=' . $val[id] . '" target="_blank">' . $val['title'] . '</a>';
                    $list[]   = $val['all_read'];
                    $list[]   = date("Y-m-d H:i:s", $val[addtime]);
                    $list[]   = "<a href='javascript:;' onclick='L_add_msg(" . $val[id] . ");' class='edit'>选择</a><script>function L_add_msg (id) {var old_msg_list = $('#msg_list').val();var new_msg_list = old_msg_list+'|'+id;$('#msg_list').val(new_msg_list);$('.news .tags_tj').before('<li class=tags_list><span>'+id+'</span><a></a></li>');}</script>";
                    $rarray[] = $list;
                }
                $table->rdata($rarray);
                break;
            default:
                $news_url = $this->LW_BASE->self_url("met_wechat", "met_wechat", "domsg_tmp");
                require_once $this->template('own/news');
                break;
        }
    }
    /**
     * 用户列表
     */
    public function douser()
    {
        global $_M;
        nav::select_nav(7);
        $action = $_M['form']['action'];

        switch ($action) {
            case 'ajax_table':
                $openid   = $_M['form']['openid'];
                $nickname = urlencode($openid);
                $search   = $openid ? "(nickname like '%{$nickname}%' OR openid = '{$openid}' OR id = '{$openid}') " : 'id != 0 ';
                $table    = load::sys_class('tabledata', 'new');
                $array    = $table->getdata($_M['table']['nwechat_user'], '*', $search, "id DESC");

                foreach ($array as $key => $val) {
                    if (!$val['nickname'] && !$val['subscribe']) {
                        $username = '【未关注】';
                    } else {
                        $username = $val['nickname'] ? urldecode($val['nickname']) : '【近期未使用】';
                    }
                    if ($val['sex'] == '0' || $val['sex'] == '') {
                        $val['sex'] = '未知';
                    } elseif ($val['sex'] == '1') {
                        $val['sex'] = '男';
                    } else {
                        $val['sex'] = '女';
                    }
                    if ($val['subscribe'] == '0' || $val['subscribe'] == '') {
                        $val['subscribe'] = '<a style="color:red">否</a>';
                    } else {
                        $val['subscribe'] = '是';
                    }
                    $val['headimgurl']     = $val['headimgurl'] ? '<img src="' . $val['headimgurl'] . '" width="100%">' : '';
                    $val['province']       = $val['province'] ? '-' . $val['province'] : '';
                    $val['city']           = $val['city'] ? '-' . $val['city'] : '';
                    $val['subscribe_time'] = date("m-d H:i", $val['subscribe_time']);
                    $list                  = array();
                    $list[]                = '<input name="id" type="checkbox" value="' . $val[id] . '"><input name="openid-' . $val[id] . '" type="hidden" value="' . $val[openid] . '">';
                    $list[]                = $val[id];
                    $list[]                = $val['headimgurl'];
                    $list[]                = $username;
                    $list[]                = '<input name="points-' . $val[id] . '" type="text" class="ui-input" value="' . $val['points'] . '">';
                    $list[]                = $val['openid'];
                    $list[]                = $val['sex'];
                    $list[]                = $val['subscribe'];
                    $list[]                = $val['country'] . $val['province'] . $val['city'];
                    $list[]                = $val['subscribe_time'];
                    $list[]                = '
                            <div class="btn-group">
                                <a href="' . $_M[url][own_form] . 'a=dopoints&openid=' . $val[openid] . '" class="btn btn-primary">查看积分详情</a>
                                <a href="' . $_M[url][own_form] . 'a=douser&action=edit&submit_type=del&allid=' . $val[id] . '" class="btn btn-danger" data-confirm="确认删除？">删除</a>
                            </div>
                        ';
                    $rarray[] = $list;
                }
                $table->rdata($rarray);
                break;
            case 'edit':
                switch ($_M['form']['submit_type']) {
                    case 'del':
                        LW::save_table("nwechat_user");
                        break;
                    case 'points':
                        $idlist = explode(",", $_M['form']['allid']);
                        foreach ($idlist as $val) {
                            $points = $_M['form']['points-' . $val];
                            $openid = $_M['form']['openid-' . $val];
                            if (is_number($val)) {
                                $this->LW_BASE->user_points($openid, 'new', $points, '管理员设置');
                            }
                        }
                        break;
                }
                turnover(HTTP_REFERER);
                break;
            default:
                require_once $this->template('own/user');
                break;
        }
    }
    public function doget_all_user()
    {
        global $_M;
        $page        = $_M['form']['page'] ? $_M['form']['page'] : 1;
        $next_openid = $_M['form']['next_openid'] ? $_M['form']['next_openid'] : '';
        $r           = $this->LW_BASE->get_all_user_openid($page, $next_openid);
        echo $this->LW_BASE->json_encode_ex($r);
    }
    public function doget_all_openid()
    {
        global $_M;
        $data = LW::sql_get_all("nwechat_user");
        if ($data) {
            foreach ($data as $key => $val) {
                $r[] = $val['openid'];
            }
        }
        echo $this->LW_BASE->json_encode_ex($r);
    }
    public function dosave_user()
    {
        global $_M;
        $openid                           = $_M['form']['openid'];
        $_SESSION['LW_BASE_userinfo_sub'] = null;
        $data                             = $this->LW_BASE->get_userinfo_sub($openid);
        if (!$data['errcode']) {
            $r['errcode'] = 1;
            $r['errmsg']  = "ok";
        } else {
            $r = $data;
        }
        echo $this->LW_BASE->json_encode_ex($r);
    }
    public function dopoints()
    {
        global $_M;
        nav::select_nav(8);
        $action = $_M['form']['action'];

        switch ($action) {
            case 'ajax_table':
                $openid = $_M['form']['openid'];
                $search = $openid ? "openid = '{$openid}'" : "id!=0";
                $search .= $_M['form']['type'] ? " AND type = '{$_M[form][type]}'" : "";
                $table = load::sys_class('tabledata', 'new');
                $array = $table->getdata($_M['table']['nwechat_log_points'], '*', $search, "id DESC");
                foreach ($array as $key => $val) {
                    $val['date']   = date("Y-m-d H:i:s", $val['date']);
                    $val['points'] = $val['points'] > 0 ? $val['points'] : '-';
                    switch ($val['type']) {
                        case 'add':
                            $type = '<span style="color:green">增加</span>';
                            break;
                        case 'del':
                            $type = '<span style="color:red">减少</span>';
                            break;
                        case 'new':
                            $type = '<span style="color:gray">设置</span>';
                            break;
                    }
                    $list     = array();
                    $list[]   = $val['openid'];
                    $list[]   = $type;
                    $list[]   = $val['points'];
                    $list[]   = $val['text'];
                    $list[]   = $val['date'];
                    $rarray[] = $list;
                }
                $table->rdata($rarray);
                break;
            default:
                require_once $this->template('own/points');
                break;
        }
    }
    public function doupdate()
    {
        global $_M;
        nav::select_nav(9);
        $update = load::own_class('admin/update', 'new');
        $update->index();
    }
    public function dohelp()
    {
        global $_M;
        nav::select_nav(10);
        $url = "//blog.luckymoke.cn/myapp/met_wechat.html";
        require_once $this->template('own/help');
    }
}
