﻿(function () {
    var myOpUserUuid, myNetZoneUuid;

    // 获取默认用户
    window.GetDefaultUser = function () {
        $.ajax({
            url: "http://10.0.50.20:8085/traffic_hub/hik_openapi/get_default_user_uuid",
            type: "GET",
            success: function (jVal) {
                console.log("获取默认用户： " + jVal);
                jVal = $.parseJSON(jVal);
                if (jVal.errorCode == 0 && jVal.data) {
                    myOpUserUuid = jVal.data;

                    GetNetZones();
                } else {
                    console.log("获取默认用户失败！");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console.log("获取默认用户失败！");
                console.log(xhr.status + ": " + thrownError);
            }
        })
    }

    // 获取网域信息
    function GetNetZones() {
        $.ajax({
            url: "http://10.0.50.20:8085/traffic_hub/hik_openapi/get_net_zones",
            type: "GET",
            data: {
                opUserUuid: myOpUserUuid
            },
            success: function (jVal) {
                console.log("获取网域： " + jVal);
                jVal = $.parseJSON(jVal);
                if (jVal.errorCode != 0) {
                    var vDesc = (jVal.errorMessage != null ? jVal.errorMessage : "getPresetInfosByCameraUuid返回失败")
                        + ",错误码为：" + jVal.errorCode;
                    console.log("获取网域信息失败：" + vDesc);
                    return;
                }

                if (jVal.data && jVal.data.length <= 0) {
                    console.log("获取网域信息成功，但无网域信息！");
                    return;
                }

                if (jVal.errorCode == 0 && jVal.data && jVal.data.length > 0) {
                    myNetZoneUuid = jVal.data[0].netZoneUuid;
                    // 获取默认控制中心

                    InitOcx();
                    SetLocalParam();

                }
            }
        })
    }


    window.playCamera = function (seledCameraUuid) {
        console.log("Play camera： " + seledCameraUuid);
        $.ajax({
            url: "http://10.0.50.20:8085/traffic_hub/hik_openapi/get_preview_param_by_camera_uuid",
            type: "GET",
            data: {
                opUserUuid: myOpUserUuid,
                cameraUuid: seledCameraUuid,
                netZoneUuid: myNetZoneUuid
            },
            success: function (xml) {
                // console.log("获取监控点预览参数： " + xml);
                xml = $.parseJSON(xml);
                // 调OCX单路预览接口
                var previewOcx = document.getElementById("previewOcx");
                if (xml.data) {
                    var ret = previewOcx.SPV_StartPreview(xml.data);
                    if (ret != 0) {
                        console.log("预览失败：" + xml.data);
                    }
                } else {
                    var vDesc = "查询预览参数失败，" + xml.errorMessage + ",错误码为：" + xml.errorCode;
                    console.log(vDesc);
                }
            }
        })
    }

    function InitOcx() {
        console.log("视频初始化");
        var ocxObj = document.getElementById("previewOcx");
        var languageType = 1;
        var ret = ocxObj.SPV_Init(languageType);
        if (ret != 0) {
            console.log("初始化失败");
        }
    }

    function UninitOcx() {
        var ocxObj = document.getElementById("previewOcx");
        var ret = ocxObj.SPV_Uninit();
        if (ret != 0) {
            console.log("反初始化失败");
        }
    }

    function SetLocalParam() {
        var ocxObj = document.getElementById("previewOcx");
        var devPxRa = screen.deviceXDPI / screen.logicalXDPI;
        var height = $('#previewOcx').height() * devPxRa;
        var width = $('#previewOcx').width() * devPxRa;
        var xml = '<?xml version="1.0" encoding="UTF-8"?> '
            + '<localParam> ' + '<width>' + width + '</width> '
            + '<height>' + height + '</height> '
            + '<picType>1</picType> '
            + '<capturePath>C:\\Hikvision</capturePath> '
            + '<recordSize>2</recordSize> '
            + '<recordPath>C:\\Hikvision</recordPath> '
            + '<limitPreviewTime>0</limitPreviewTime> '
            + '<showMsgTip>1</showMsgTip> '
            + '</localParam>';
        var ret = ocxObj.SPV_SetLocalParam(xml);
        if (ret != 0) {
            console.log("单路预览设置本地参数失败");
        }
    }

    window.stopSinglePreview = function () {
        var ocxObj = document.getElementById("previewOcx");
        var ret = ocxObj.SPV_StopPreview ? ocxObj.SPV_StopPreview() : 1;
        if (ret != 0) {
            console.log("停止单路预览失败");
        }
    }
})();
