var billBoard = new ht.Node();
billBoard.s({
    "3d.visible": false,
    "all.color": "#DDDDDD",
    "shape3d": "billboard",
    "shape3d.reverse.cull": true,
    "shape3d.image": "symbols/客运中心/客流.json",
    "shape3d.transparent": true,
    "shape3d.autorotate": true,
    "shape3d.fixSizeOnScreen": [ -1, -1 ]
});
billBoard.setAnchorElevation(0);

var currentNode;
var address = ['售票出口', '侯車室', '入站'];

ht.Default.setImage('symbols/客运中心/客流.json');
ht.Default.setImage('symbols/客运中心/摄像头点击.json');

var g3d = new ht.graph3d.Graph3dView();
g3d.getView().style.background = 'rgb(61, 61, 61)';
g3d.setFar(1000000);
g3d.setMovableFunc(function(){return false});
g3d.onDataDoubleClicked = function (data) {
    var tag = data.getTag();
    if (tag === 'centerBuild') {
        switchScene('scenes/客运中心/一层.json');
    }
    else if (tag === 'divisionBuild') {
        switchScene('scenes/司乘用房/一层.json');
    }
};
g3d.getView().addEventListener('mousemove', function (e) {
    var node = g3d.getDataAt(e);
    if (currentNode && currentNode === node) {
        return;
    }

    billBoard.removeFromDataModel();
    currentNode = node;
    if (node) {
        var shape3d = node.s('shape3d'),
            displayName = node.getDisplayName(),
            obj = {}, p3, image;
        if (displayName === 'LED' || displayName === 'LCD') {
            var num = parseInt(Math.random() * 3) + 1;
            obj['name'] = '交通信息' + String(num) + '号屏';
            obj['code'] = 'HT' + String(num * 1000);
            obj['address'] = address[num - 1];

            p3 = [node.getX(), node.getElevation() + 400, node.getY()];
            image = 'symbols/客运中心/led悬停.json';
        }
        else if (shape3d) {
            if (shape3d.indexOf('视频监控') > -1) {
                var num = parseInt(Math.random() * 10) + 1;
                var name = shape3d.substring(shape3d.lastIndexOf('/') + 1, shape3d.lastIndexOf('.'));
                obj['name'] = '商业' + String(num) + '号' + name;
                obj['code'] = 'HT' + String(num * 1000);
                obj['address'] = address[num - 1];

                p3 = [node.getX(), node.getElevation() + 200, node.getY()];
                image = 'symbols/客运中心/摄像头悬停.json';
            } else if (shape3d.indexOf('电梯') > -1) {
                var num = parseInt(Math.random() * 3) + 1;
                obj['code'] = 'HT' + String(num * 1000);
                obj['address'] = address[num - 1] + '电梯';

                p3 = [node.getX(), node.getElevation() + 400, node.getY()];
                image = 'symbols/客运中心/电梯.json';
            } else if (shape3d.indexOf('扶梯') > -1) {
                var num = parseInt(Math.random() * 3) + 1;
                obj['code'] = 'HT' + String(num * 1000);
                obj['name'] = address[num - 1] + '自动扶梯';
                obj['status'] = num % 2 === 0 ? '上行' : '下行';
                var rotation = Math.PI * (num % 2);
                obj['statusIcon'] = rotation;

                p3 = [node.getX(), node.getElevation() + 500, node.getY()];
                image = 'symbols/客运中心/扶梯.json';
            } else if (shape3d.indexOf('空调') > -1) {
                var num = parseInt(Math.random() * 3) + 1;
                obj['code'] = 'HT' + String(num * 1000);
                obj['name'] = String(num) + '号空调';
                obj['address'] = address[num - 1];
                obj['Hz'] = String(num) + '级';

                p3 = [node.getX(), node.getElevation() + 500, node.getY()];
                image = 'symbols/客运中心/空调.json';
            }
        }

        if (!p3) return;

        billBoard.s({
            "shape3d.image": image,
            "3d.visible": true
        });
        billBoard.p3(p3);
        g3d.dm().add(billBoard);
    }
});
g3d.onDataClicked = function (data) {
    var shape3d = data.s('shape3d');
    if (shape3d && shape3d.indexOf('客流采集') > -1) {
        showDialog('客流采集', data.a('uuid'));
    }
    else if (shape3d && shape3d.indexOf('视频监控') > -1) {
        showDialog('视频监控', data.a('uuid'));
    }
}

var videoShowing = false;
var g2d = new ht.graph.GraphView();
g2d.setPannable(false);
g2d.setRectSelectable(false);
g2d.handleScroll = function () { };
g2d.onBackgroundClicked = function (e) {
    g2d.dm().each(function (d) {
        if (d.getTag() && d.getTag().indexOf('Floor') >= 0) return;

        d.s('2d.visible', false);
    });

    if (videoShowing) {
        stopSinglePreview();
        videoShowing = false;
    }
}

function showDialog(tag, uuid) {
    var dm = g2d.dm();
    var node = dm.getDataByTag(tag);
    node.s('2d.visible', true);

    if (tag === '视频监控' && uuid) {
        playCamera(uuid);
        videoShowing = true;
    }
}

var centerList = [
    'scenes/客运中心/机房层.json',
    'scenes/客运中心/二层.json',
    'scenes/客运中心/夹层.json',
    'scenes/客运中心/一层.json',
    'scenes/客运站.json'
];
var divisionList = [
    'scenes/司乘用房/三层.json',
    'scenes/司乘用房/二层.json',
    'scenes/司乘用房/夹层.json',
    'scenes/司乘用房/一层.json',
    'scenes/客运站.json'
];
var sceneMap = {};
var defaultCallback = function () {
    g3d.flyTo(null, {
        animation: true,
        worldDirection: [0, 0.5, 1],
        ratio: 1
    });

    layoutNodes();
}
function updateFloor(floor, position, visible) {
    var node;
    if (floor === 'center') node = centerFloor;
    else if (floor === 'division') node = divisionFloor;

    if (!node) {
        ht.Default.callLater(function () {
            updateFloor(floor, position, visible);
        });
        return;
    }
    node.a('position', position);
    node.s('2d.visible', visible);
}
function switchScene(url, cb) {
    cb = cb || defaultCallback;

    var dm = sceneMap[url];
    if (!dm) {
        dm = sceneMap[url] = new ht.DataModel();
    }

    g3d.dm(dm);

    var index = centerList.indexOf(url);
    updateFloor('center', 35 + index * 42.5, index >= 0 && index !== 4);

    index = divisionList.indexOf(url);
    updateFloor('division', 35 + index * 42.5, index >= 0 && index !== 4);

    updateLayerPanel(url);

    if (dm.size() === 0) {
        ht.Default.xhrLoad(url, function (json) {
            dm.deserialize(json);
            cb();
        });
        return;
    }

    cb();
}

var centerFloor, dialogList, divisionFloor;
window.addEventListener('load', function () {
    g3d.addToDOM();

    g2d.addToDOM();
    g3d.getView().appendChild(g2d.getView());

    var dm2d = g2d.dm();
    ht.Default.xhrLoad('displays/panels.json', function (json) {
        dm2d.deserialize(json);

        var size = viewNode.getScaledSize();

        centerFloor = dm2d.getDataByTag('centerFloor');
        centerFloor.setHost(viewNode);
        centerFloor.s({
            '2d.visible': false,
            'layout.h': 'right',
            'layout.v': 'top'
        });
        centerFloor.setAnchor(1, 0);
        centerFloor.setPosition(size.width - 10, 10);

        divisionFloor = dm2d.getDataByTag('divisionFloor');
        divisionFloor.setHost(viewNode);
        divisionFloor.s({
            '2d.visible': false,
            'layout.h': 'right',
            'layout.v': 'top'
        });
        divisionFloor.setAnchor(1, 0);
        divisionFloor.setPosition(size.width - 10, 10);

        dialogList = dm2d.getDataByTag('dialogList').getChildren().toArray();
        dialogList.forEach(function (c) {
            c.setHost(viewNode);
            c.s({
                '2d.visible': false,
                'layout.h': 'center',
                'layout.v': 'center'
            });
            c.setPosition(size.width * 0.5, size.height * 0.5);
        });
    });

    createLayerPanel();

    switchScene('scenes/客运站.json');

    GetDefaultUser();
});

function layoutNodes() {
    centerFloor.layout(viewNode);

    divisionFloor.layout(viewNode);

    var size = viewNode.getScaledSize();
    dialogList.forEach(function (c) {
        c.setPosition(size.width * 0.5, size.height * 0.5);
    });
}
window.addEventListener('resize', function () {
    setTimeout(layoutNodes, 100);
});

var viewNode = new ht.Node();
viewNode.s('2d.visible', false);
viewNode.getPosition = function () {
    var rect = g2d.getViewRect();
    return { x: rect.x, y: rect.y };
};
viewNode.getAnchor = function () {
    return { x: 0, y: 0 };
};
viewNode.getScaledSize = function () {
    var rect = g2d.getViewRect();
    return { width: rect.width, height: rect.height };
};

// 时间定时器
var weekNoList = ['日', '一', '二', '三', '四', '五', '六']
setInterval(function() {
    var dm = g3d.dm(),
        divisionPane = dm.getDataByTag('divisionPane');
    if (divisionPane) {
        var now = new Date();
        divisionPane.a({
            day: '星期' + weekNoList[now.getDay()],
            date: now.getFullYear() + '-' + (now.getMonth() + 1) + '-' + now.getDate(),
            time: now.getHours() + ':' + now.getMinutes()
        });
    }
}, 1000);

// 图层面板
function createLayerPanel () {
    var layerGv = new ht.graph.GraphView();
    layerGv.getSelectWidth = function() {return 0;};
    layerGv.handleScroll = function() {};
    layerGv.handlePinch = function() {};
    layerGv.setPannable(false);
    layerGv.setRectSelectable(false);
    layerGv.setScrollBarVisible(false);
    layerGv.setMovableFunc(function() {return false;});

    ht.Default.xhrLoad('displays/图层选择.json', function(json){
        layerGv.dm().deserialize(json);
        layerGv.fitContent();
    });
    var panel = window.layerPanel = new ht.widget.Panel({
        title: '图层选择',
        width: 250,
        expanded: false,
        titleBackground: '#bcdbf8',
        titleColor: '#111',
        narrowWhenCollapse: true,
        contentHeight: 370,
        content: layerGv
    });

}
function updateLayerPanel(url) {
    if (url !== 'scenes/客运站.json' && layerPanel.getView().parentNode !== document.body) {
        document.body.appendChild(layerPanel.getView());
    }
    else if (url === 'scenes/客运站.json' && layerPanel.getView().parentNode === document.body){
        document.body.removeChild(layerPanel.getView());
    }

}