<?php
defined('IN_MET') or exit('No permission');
load::sys_class('app');
load::sys_func('file');

class met_picture_clean extends app
{

    public $images_txt;

    public $ico;

    public function __construct()
    {
        global $_M;
        parent::__construct();
        nav::set_nav(1, '图片清理', $_M['url']['own_form'] . 'a=doindex');
        nav::set_nav(2, '清理记录',$_M['url']['own_form'].'a=dologs');
        nav::set_nav(3, '帮助中心','http://help.metinfo.cn/faq/353.html', '_blank');
        $this->images_txt = PATH_APP_FILE.'logs/images.txt';
        $this->ico = array(
            'xls'=>'fa-file-excel-o',
            'xlsx'=>'fa-file-excel-o',
            'pdf'=>'fa-file-pdf-o',
            'mp3'=>'fa-file-audio-o',
            'wav'=>'fa-file-audio-o',
            'flv'=>'fa-file-video-o',
            'mp4'=>'fa-file-video-o',
            'doc'=>'fa-file-word-o',
            'docx'=>'fa-file-word-o',
            'txt'=>'fa-file-text',
            'ppt'=>'fa-file-powerpoint-o',
            'pptx'=>'fa-file-powerpoint-o',
            'php'=>'fa-file-code-o',
            'asp'=>'fa-file-code-o',
            'html'=>'fa-file-code-o',
            'exe'=>'fa-file-code-o',
            'htm'=>'fa-file-code-o',
            'sql'=>'fa-file-code-o',
            'rar'=>'fa-book',
            'zip'=>'fa-book'
        );
    }

    public function doindex()
    {
        global $_M;
        nav::select_nav(1);
        clearstatcache();
        $this->input['temp_path'] = 'app/app/met_picture_clean/logs/'.date('Ymd');
        $this->input['log_path'] = PATH_APP_FILE.'logs';
        $this->input['log_write'] = is_writable($this->input['log_path']);
        require $this->show('app/index',$this->input);
    }

    public function doget_tables()
    {
        global $_M;
        $tables = array();
        foreach ($_M['table'] as $key => $val) {
            $tables[] = $key;
        }
        @unlink($this->images_txt);
        echo json_encode($tables);die;
    }

    public function doscan_table()
    {
        global $_M;
        $table = $_M['form']['table'];
        $data = $this->table($table)->get();
        $images = array();
        foreach ($data as $key => $val) {
            foreach ($val as $k => $v) {
                $res = $this->check_image($v);
                if($res){
                    foreach ($res as $key => $img) {
                        if($img){
                            if (strstr($img, 'watermark')) {
                                file_put_contents($this->images_txt, $img."\n",FILE_APPEND);
                                $images[] = $img;
                            }
                            $img = str_replace('/watermark', '', $img);
                            file_put_contents($this->images_txt, $img."\n",FILE_APPEND);
                            $images[] = $img;
                        }
                    }
                }
            }
        }

        if($images){
            $images = array_flip($images);
        }
        echo json_encode(array('status'=>1,'data'=>$images));die;
    }

    public function dodiff_images()
    {
        global $_M;

        if($_M['form']['name']){
            $diff = $this->get_log_list($_M['form']['name']);
        }else{
            $diff= $this->get_diff_images();
        }
        
        rsort($diff);
        $images = array(
            'jpg','png','gif','bmp','ico','jpeg'
        );
        $html = "";
        foreach ($diff as $key => $file) {
            $info = pathinfo($file);
            $ext = $info['extension'];
            $ico = $this->ico[$ext] ? $this->ico[$ext] : 'fa-file';
            if(in_array($ext, $images)){
                $img = $_M['url']['site'].$file;
                $type = "<img data-original=\"{$img}\">";
            }else{
                $type = "<i class=\"fa {$ico}\"></i>";
            }
            $name = $info['basename'];
            $html .= "<a target='_blank' class='col-xs-2 text-xs-center' href=\"{$_M['url']['site']}{$file}\">{$type}<p class='text-xs-center'>{$name}</p></a>";
        }
        $data = array(
            'total'=>count($diff),
            'data'=>$html,
        );
        if($html){
            $data['status'] = 1;
        }else{
            $data['status'] = 0;
        }
        echo json_encode($data);die;
      
    }

    public function get_diff_images()
    {
        global $_M;
        if(!file_exists($this->images_txt)){
            return 0;
        }
        
        #$upload_images = traversal(PATH_WEB.'upload','[a-zA-Z0-9]{3,4}','upload\/thumb_src|upload\/\d{6}\/watermark');
        $upload_images = traversal(PATH_WEB.'upload','[a-zA-Z0-9]{3,4}','upload\/thumb_src');
        $upload_images = array_keys(array_flip($upload_images));
        $database_images = explode("\n", trim(file_get_contents($this->images_txt)));
        $database_images = array_keys(array_flip($database_images));
            
        $diff = array_values(array_diff($upload_images,$database_images));

        return $diff;
    }

    public function get_log_list($path)
    {
        global $_M;
        $log_list = traversal(PATH_APP_FILE.'logs/'.$path,'[a-zA-Z0-9]{3,4}');
        return $log_list;
    }

    public function check_image($val)
    {
        global $_M;
        $images = array();
        preg_match_all("/upload\/[^\s\*\|]+\.([a-zA-Z0-9]{3,4})/i",$val,$match);
        if($match[0]){
            foreach ($match[0] as $key => $img){
                $images[] = $img;
            }
        }
        return $images;
    }

    public function doclear_images()
    {
        global $_M;
        $diff_images = $this->get_diff_images();
        $new_dir = PATH_APP_FILE.'logs/'.date('Ymd');
        foreach ($diff_images as $key => $img) {
            $img = iconv("utf-8","gb2312//TRANSLIT",$img);
            $new_file = $new_dir.'/'.$img;
            $info = pathinfo($new_file);
            if(!file_exists($info['dirname'])){
                $create = mkdir($info['dirname'],0777,true);
                if(!$create){
                    echo json_encode(array('status'=>0,'msg'=>$info['dirname'].'创建失败'));die;
                }
            }

            rename(PATH_WEB.$img, $new_file);
        }

        @unlink($this->images_txt);
        echo json_encode(array('status'=>1,'msg'=>'操作成功'));
    }

    public function dologs()
    {
        global $_M;
        nav::select_nav(2);
        require $this->show('app/logs');
    }

    public function dologs_list()
    {
        global $_M;
        $array = scandir(PATH_APP_FILE.'logs');
        rsort($array);
        foreach ($array as $v) {
            if(strstr($v, '.')){
                continue;
            }
            $list = array();
            $list[] ="<td class='text-xs-center'>
                    <span class='checkbox-custom checkbox-primary'>
                        <input type='checkbox' name='id' value=\"{$v}\"  class='selectable-item'>
                        <label></label>
                    </span>
                </td>";
            $list[] = $v;
            $imgs = traversal(PATH_APP_FILE.'logs/'.$v);
            $list[] = count($imgs);

            $list[] = "<button class='btn btn-info btn-xs show_log' data-toggle=\"modal\" data-target=\"#show_log\"  data-name=\"{$v}\" data-url=\"{$_M['url']['own_form']}a=dodiff_images&name={$v}\">查看</button> <button class='btn btn-danger btn-xs delete_log' data-name=\"{$v}\" data-url=\"{$_M['url']['own_form']}a=dodelete_log\">删除</button>";
            $rarray[] = $list;
        }
        $this->table = load::sys_class('tabledata', 'new');
        $this->table->rarray['recordsTotal'] = $this->table->rarray['recordsFiltered']  = 10;  //回传总数量
        $this->table->rdata($rarray);
    }
    

    public function dodelete_log()
    {
        global $_M;
        $name = trim($_M['form']['name']);
        if(preg_match('/^\d{8}$/', $name) && file_exists(PATH_APP_FILE.'logs/'.$name)){
            self::deletedir(PATH_APP_FILE.'logs/'.$name.'/');
            $del = @rmdir(PATH_APP_FILE.'logs/'.$name.'/');
            echo json_encode(array('status'=>1,'msg'=>'删除成功'));die;
        }
        echo json_encode(array('status'=>0,'msg'=>'目录不正确'));die;
    }

    public function deletedir($path){
       if(is_dir($path)){
            $p = scandir($path);
            foreach($p as $val){
                if(is_dir($path.$val)){
                    if(strstr($val, '.')){
                        continue;
                    }
                    self::deletedir($path.$val.'/');
                    @rmdir($path.$val.'/');
                 }else{
                    @unlink($path.$val);
                 }
            }
        }
    }
}